import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

import java.io.*;

// アプリ本体
public class Java_Fusen_Apps extends JFrame implements ActionListener, MouseListener{

	// ■　定数
	// 付箋(画面)サイズ縦横
	public final static int FUSEN_SIZE_HEIGH = 300;
	public final static int FUSEN_SIZE_WIDTH = 400;
	
	// 付箋枚数　このアプリは10枚の付箋シートを持つ
	public final static int FUSEN_SHEETS_MIN = 0;
	public final static int FUSEN_SHEETS_MAX = 10;
	
	// メニュー項目が子要素(メニューアイテムを持つか否か)
	// 子要素あり　JＭenuとして登録する
	public final static int HAVE_CHILD = 0;    // 識別に使っているだけで数字に意味はなし
	// 子要素なし　JMenuItemとして登録する
	public final static int NONE_CHILD = 99;

	// ■　広域変数
	// datファイルの名称
	public final static String st_fusen_dat = "fusen.dat";
	
	// 付箋シートクラス
	public static cFusen_Sheets cl_fusen_sheet = new cFusen_Sheets(FUSEN_SHEETS_MAX);

	// カレントインデックス
	public static int idx_current_sheet = FUSEN_SHEETS_MIN;
	
	// メニュー項目に設定するテキストの配列
	public final static String[] st_Menu_Array = {"付箋一覧", "　", "◁", "▷", "　", "全てクリア", "クリア", "保存"};

	// メニュー項目の子要素の有無の設定
	public final static int[] it_Menu_Array = {HAVE_CHILD, NONE_CHILD, NONE_CHILD, NONE_CHILD, NONE_CHILD, NONE_CHILD, NONE_CHILD, NONE_CHILD};

	// メニューアイテムに設定するテキストの配列
	public static String st_Item_Array[][] = {
		    {"01" , "02" , "03" , "04" , "05" , "06" , "07" , "08" , "09" , "10"}
		};

	// テキストエリア　画面を作成するmain()以外からも使用される
	public static JTextArea txt_area = new JTextArea();

    // ステータスバー　画面を作成するmain()以外からも使用される
	public static JLabel st_bar = new JLabel();
 
 // ■　関数
	// メイン関数
	public static void main(String[] args){

		// datファイルが存在するか確認
		try(FileInputStream check_file = new FileInputStream(st_fusen_dat)) {
		// 存在しなければ作成
		} catch ( FileNotFoundException e ) {
			try(FileOutputStream make_file = new FileOutputStream(st_fusen_dat);
				BufferedOutputStream buffer_output = new BufferedOutputStream(make_file);
				ObjectOutputStream obuject_output = new ObjectOutputStream(buffer_output)){
				cFusen_Sheets make_dat = new cFusen_Sheets(FUSEN_SHEETS_MAX);
				obuject_output.writeObject(make_dat);
			} catch ( FileNotFoundException f ) {
				f.printStackTrace();
			} catch ( IOException f ) {
				f.printStackTrace();
			}
		} catch ( IOException e ) {
			e.printStackTrace();
		}

		// datファイルを読み込む
		try(FileInputStream input_file = new FileInputStream(st_fusen_dat);
			BufferedInputStream buffer_stream = new BufferedInputStream(input_file);
			ObjectInputStream ofject_stream = new ObjectInputStream(buffer_stream)) {
			cl_fusen_sheet = (cFusen_Sheets) ofject_stream.readObject();
		} catch ( IOException e ) {
			e.printStackTrace();
		} catch ( ClassNotFoundException e ) {
			e.printStackTrace();
		}

	  // フレーム作成
	  Java_Fusen_Apps top_frame = new Java_Fusen_Apps("付箋", FUSEN_SIZE_WIDTH, FUSEN_SIZE_HEIGH);
	  // フレームを画面の中央に配置
		top_frame.setLocationRelativeTo(null);
	  // フレーム表示
		top_frame.setVisible(true);
  }
 
	// コンストラクタ
	Java_Fusen_Apps(String title, int width, int heigh){
	  // タイトル設定
	  setTitle(title);
	  // サイズ設定
	  setSize(width, heigh);

	  // クローズ動作　標準
	  setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	  
	  // メニューバー作成
	  JMenuBar menu_bar = new JMenuBar();
	  
	  // st_Menu_Arrayに設定されている項目をメニューバーに登録する
    for(int i = 0; i < st_Menu_Array.length; i++){
  	  // 子要素(メニューアイテム)を持っている場合
  	  if(it_Menu_Array[i] == HAVE_CHILD){
  		  // メニュー作成
  		  JMenu menu_koumoku = new JMenu(st_Menu_Array[i]);
  		  // メニューバーに登録
  		  menu_bar.add(menu_koumoku);
  		  // 子要素(メニューアイテム)の作成
  		  for(int j = 0; j < st_Item_Array[i].length; j++){
  			  JMenuItem menu_item = new JMenuItem(st_Item_Array[i][j]);
  			  // アクションリスナー登録
  			  menu_item.addActionListener(this);
  			  // メニューに登録
  			  menu_koumoku.add(menu_item);
  			  }
  		  // 子要素(メニューアイテム)を持っていない場合
		  }else {
			  // メニュー項目の指定が全角スペースなら可変長の余白をメニューバーに挿入する
			  if(st_Menu_Array[i] == "　") {
				  menu_bar.add(Box.createGlue());
			  // そうでなければメニューアイテムとして追加
			  }else {
				  JMenu menu_koumoku = new JMenu(st_Menu_Array[i]);
				  // マウスイベント登録でクリック検知
				  menu_koumoku.addMouseListener(this);
				  // メニューバーに登録
	  			  menu_bar.add(menu_koumoku);
			  }			  
		  }
    }

    // メニューバーをフレームに登録
    setJMenuBar(menu_bar);

      // テキストエリアの設定
    txt_area.setBackground(Color.CYAN);
    txt_area.setLineWrap(true);
    txt_area.setFont(new Font("ＭＳ ゴシック", Font.BOLD, 24));
    txt_area.setTabSize(4);
    // テキストエリアをフレームに登録
    add(txt_area);
    // テキストエリアにデータを読み込んで表示する
    CurrentSheetChange(idx_current_sheet);

      // ステータスバー(もどき)の設定
      st_bar.setText((idx_current_sheet + 1) + "/" + FUSEN_SHEETS_MAX + "枚目");
		st_bar.setFont(new Font("ＭＳ ゴシック", Font.BOLD, 14));
		st_bar.setHorizontalAlignment(JLabel.RIGHT);
		st_bar.setOpaque(true);
		st_bar.setBackground(Color.CYAN);
		// ステータスバーをフレームに登録
		add(st_bar, BorderLayout.PAGE_END);
  }
  
  // アプリで使用する付箋シートデータを格納するクラス
  public static class cFusen_Sheets implements Serializable{
	  String[] text;
	  int max;

		// コンストラクタ
		cFusen_Sheets(int max){
			this.text = new String[FUSEN_SHEETS_MAX];
			this.max = FUSEN_SHEETS_MAX;
		}
	}
 
  // マウスイベントを受け取った際の動作を定義する
  public void mouseClicked(MouseEvent e){
	  // イベントの文字情報を抽出
	  String com = new String(e.getSource().toString());

	  // クリックされたメニューの種類を判別
	  if(com.contains("◁")){
    	  if(idx_current_sheet > FUSEN_SHEETS_MIN) {
    		  CurrentSheetChange(idx_current_sheet - 1);  
    	  }
  	  }else if(com.contains("▷")){
    	  if(idx_current_sheet < (FUSEN_SHEETS_MAX - 1)) {
    		  CurrentSheetChange(idx_current_sheet + 1);  
    	  }
  	  }else if(com.contains("全てクリア")){
  		AllSheetClear();
  	  }else if(com.contains("クリア")){
  		CurrentSheetClear();
  	  }else if(com.contains("保存")){
  		CurrentSheetSave();
  	  }
    }
 
  // その他のマウスイベント群
  // 実装していないとエラーになる
  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){}
  public void mousePressed(MouseEvent e){}
  public void mouseReleased(MouseEvent e){}
  
  // アクションイベントを受け取った際の動作を定義する
  public void actionPerformed(ActionEvent e) {
	  // クリックされたメニューアイテムを判別
      switch(e.getActionCommand()){
          case "01":
        	  CurrentSheetChange(0);
              break;
          case "02":
        	  CurrentSheetChange(1);
              break;
          case "03":
        	  CurrentSheetChange(2);
              break;
          case "04":
        	  CurrentSheetChange(3);
              break;
          case "05":
        	  CurrentSheetChange(4);
              break;
          case "06":
        	  CurrentSheetChange(5);
              break;
          case "07":
        	  CurrentSheetChange(6);
              break;
          case "08":
        	  CurrentSheetChange(7);
              break;
          case "09":
        	  CurrentSheetChange(8);
              break;
          case "10":
        	  CurrentSheetChange(9);
              break;
      }
  }

  // 表示するシートが変わった
  public void CurrentSheetChange(int newidx){
	// カレントインデックス変更
	idx_current_sheet = newidx;
	// テキストエリア書き換え
	txt_area.setText(cl_fusen_sheet.text[idx_current_sheet]);
	// ステータスバー書き換え
	st_bar.setText((idx_current_sheet + 1) + "/" + FUSEN_SHEETS_MAX + "枚目");
	}

  //全てのシートのデータを削除する
  public void AllSheetClear(){
	// cl_fusen_sheet.textの内容を全て空に
	for(int i = FUSEN_SHEETS_MIN; i < FUSEN_SHEETS_MAX; i++) {
		cl_fusen_sheet.text[i] = "";
	}
	// テキストエリア更新
	txt_area.setText(cl_fusen_sheet.text[idx_current_sheet]);
	// 保存
	CurrentSheetSave();
	st_bar.setText("全てのシートをクリアしました！　　" + (idx_current_sheet + 1) + "/" + FUSEN_SHEETS_MAX + "枚目");
	}
  
  // 現在表示しているシートのクリア
  public void CurrentSheetClear(){
	// 今表示しているcl_fusen_sheet.textの内容を空に
	cl_fusen_sheet.text[idx_current_sheet] = "";
	// テキストエリア更新
	txt_area.setText(cl_fusen_sheet.text[idx_current_sheet]);
	// 保存
	CurrentSheetSave();
	st_bar.setText("シートをクリアしました！　　" + (idx_current_sheet + 1) + "/" + FUSEN_SHEETS_MAX + "枚目");
	}

  // 保存
  public void CurrentSheetSave(){
	// 付箋シートクラスに現在のテキストエリアの内容を格納
	cl_fusen_sheet.text[idx_current_sheet] = txt_area.getText();

	// datファイルへ書き出し
	try(FileOutputStream make_file = new FileOutputStream(st_fusen_dat);
		BufferedOutputStream buffer_output = new BufferedOutputStream(make_file);
		ObjectOutputStream obuject_output = new ObjectOutputStream(buffer_output)){
		obuject_output.writeObject(cl_fusen_sheet);
	} catch ( FileNotFoundException e ) {
		e.printStackTrace();
	} catch ( IOException e ) {
		e.printStackTrace();
	}
	st_bar.setText("セーブ終了！　　" + (idx_current_sheet + 1) + "/" + FUSEN_SHEETS_MAX + "枚目");
	}

}